#!/usr/bin/perl
my $file;
my $simulation_time;
my $nb_steal;
my $nb_fail_steal;
my $nb_transfert;
my %tasks;
my %edges;
my %edges_machine;
print "file\ttime\tnb steal\tnb failed steal\tsuccess steal\tnb transfert\n";
$file=$ARGV[0];
my $file_output=$ARGV[0].".jed";
my $nb_m=$ARGV[1];
	open( WRITE, ">", "$file_output");
	print WRITE "<?xml version=\"1.0\"?>\n";
	print WRITE "<grid_schedule>\n";
	print WRITE "   <grid_info>\n"; 
	print WRITE "      <info name=\"nb_clusters\" value=\"1\"/>\n"; 
	print WRITE "         <clusters>\n"; 
	print WRITE "            <cluster id=\"1\" hosts=\"$nb_m\" first_host=\"0\"/>\n"; 
	print WRITE "         </clusters>\n";
	
	print WRITE "      </grid_info>\n"; 
	print WRITE "   <node_infos>\n"; 


	$simulation_time=0;
	$nb_fail_steal=0;
	$nb_steal=0;
	$nb_transfert=0;
	open( EXEC, "<", "$file");
	while(<EXEC>){
		if(/Simulation\s*time\s*(\S*)/){
			$simulation_time=$1;
		}
		if(/.* (\d+(.\d+)?)].*Processing "(\S*)"/){
			$tasks{$3}=$1;
		}
		if(/.* (\d+(.\d+)?)].*"(\S*)" done by (\d*)/){
		  next unless defined $tasks{$3};
			print WRITE "      <node_statistics>\n";
			print WRITE "         <node_property name=\"id\" value=\"$3\"/>\n";
			print WRITE "         <node_property name=\"type\" value=\"computation\"/>\n";
			print WRITE "         <node_property name=\"start_time\" value=\"".$tasks{$3}."\"/>\n";
			print WRITE "         <node_property name=\"end_time\" value=\"$1\"/>\n";
			print WRITE "         <configuration>\n";
			print WRITE "            <conf_property name=\"cluster_id\" value=\"0\"/>\n";
			print WRITE "            <conf_property name=\"host_nb\" value=\"1\"/>\n";
			print WRITE "            <host_lists>\n";
			print WRITE "               <hosts start=\"$4\" nb=\"1\"/>\n";
			print WRITE "            </host_lists>\n";
			print WRITE "         </configuration>\n";
			print WRITE "      </node_statistics>\n";
		}
		if(/Sending "request"/){
			$nb_steal++;
		}
		if(/Sending "NO_Task"/){
			$nb_fail_steal++;
		}
		if(/.* (\d+(.\d+)?)].*Received "data_(\S*)"\s*by\s*"(\d+)"/ or /.* (\d+(.\d+)?)].*Received "send_data_(\S*)"\s*by\s*"(\d+)"/){
		  next unless defined $edges{$3};
			print WRITE "      <node_statistics>\n";
			print WRITE "         <node_property name=\"id\" value=\"$3\"/>\n";
			print WRITE "         <node_property name=\"type\" value=\"transfer\"/>\n";
			print WRITE "         <node_property name=\"start_time\" value=\"".$edges{$3}."\"/>\n";
			print WRITE "         <node_property name=\"end_time\" value=\"$1\"/>\n";
			print WRITE "         <configuration>\n";
			print WRITE "            <conf_property name=\"cluster_id\" value=\"0\"/>\n";
			print WRITE "            <conf_property name=\"host_nb\" value=\"1\"/>\n";
			print WRITE "            <host_lists>\n";
			print WRITE "               <hosts start=\"".$edges_machine{$3}."\" nb=\"1\"/>\n";
			print WRITE "               <hosts start=\"$4\" nb=\"1\"/>\n";
			print WRITE "            </host_lists>\n";
			print WRITE "         </configuration>\n";
			print WRITE "      </node_statistics>\n";
		}
		if(/.* (\d+(.\d+)?)].*Sending "data_(\S*)".*\s*by\s*"(\d+)"/ or /.* (\d+(.\d+)?)].*Sending "send_data_(\S*)".*\s*by\s*"(\d+)"/){
			$edges{$3}=$1;
			$edges_machine{$3}=$4;
			$nb_transfert++;
		}
	}
	close(EXEC);
	print WRITE "   </node_infos>\n";
	print WRITE "</grid_schedule>\n";
	close(WRITE);

	my $succ_steal=$nb_steal - $nb_fail_steal;
	print "$file\t$simulation_time\t$nb_steal\t$nb_fail_steal\t$succ_steal\t$nb_transfert\n" unless ($simulation_time==0);
	warn " $file : wrong file\n" if ($simulation_time==0);

