#include "type_data.h"
XBT_LOG_EXTERNAL_DEFAULT_CATEGORY(m);


/** Choice of the stolen processor */
int stolen_proc(){
  int size = slaves_count;
  if (size == 1)
    return -1;
  return rand() % size;
} /** end stolen proc */



/* send a steal request */
m_task_t steal(int id ){
  m_task_t task;
  MSG_error_t res;
  int target = id;
  char mailbox[64];
  while(target==id){
    target=stolen_proc();
  }
  if (target == -1) {
    XBT_INFO("Bug append %d", slaves_count);
    return NULL;
  }
  /** send a steal attempt */
  char * name = "request";
  task = MSG_task_create(name, REQUEST_COST, 100, &id);
#ifdef TRACE
  TRACE_msg_set_task_category(task, "REQUEST");
#endif
#ifdef visu
  XBT_INFO("s %g %d %d",MSG_get_clock(), id , target);
#endif
#ifndef visu
#ifndef light
  XBT_INFO("Sending \"%s\" to \"%s\"", task->name, worker[target]->name);
#endif
#endif
  sprintf(mailbox, "%s_task", worker[target]->name);
  MSG_task_send(task, mailbox);
  //	XBT_INFO("Sent");

  task=NULL;
  sprintf(mailbox, "%s_exe", worker[id]->name);
  res = MSG_task_receive(&task, mailbox);
  xbt_assert(res == MSG_OK, "MSG_task_get failed");
#ifndef visu
#ifndef light
  XBT_INFO("Recieve \"%s\" to \"%s\"", task->name, worker[target]->name);
#endif
#endif
  if (MSG_task_get_data(task) == FINALIZE) {
  }else if (MSG_task_get_data(task) != NO_TASK){
#ifdef visu
    XBT_INFO("o %g %d %d",MSG_get_clock(), id, target);
#endif
  }else{
#ifdef visu
    XBT_INFO("m %g %d %d",MSG_get_clock(), id, target);
#endif
  }
  return task;
}

