#include "msg/msg.h"            /* Yeah! If you want to use msg, you need to include msg/msg.h */
#include "xbt/log.h"
#include "xbt/asserts.h"
XBT_LOG_EXTERNAL_DEFAULT_CATEGORY(m);
extern int slaves_count;
extern m_host_t *worker;


/** Choice of the stolen processor */
int stolen_proc(){
  int size = slaves_count;
	if (size == 0)
		return -1;
	return rand() % size;
} /** end stolen proc */



/* send a steal request */
m_task_t steal(int id ){
	m_task_t task;
	MSG_error_t res;
	int target = id;
	char mailbox[64];
	while(target==id){
		target=stolen_proc();
	}

	/** send a steal attempt */ 
	char * name = "request";
	task = MSG_task_create(name, 100000, 100, (void*)id);
	INFO2("Sending \"%s\" to \"%s\"", task->name, worker[target]->name);
	sprintf(mailbox, "%s_task", worker[target]->name);
	MSG_task_send(task, mailbox);
//	INFO0("Sent");

	task=NULL;
	sprintf(mailbox, "%s_exe", worker[id]->name);
	res = MSG_task_receive(&task, mailbox);
	xbt_assert0(res == MSG_OK, "MSG_task_get failed");
	return task;
}

