#!/usr/bin/perl
use strict;
use warnings;
my $default_size_node = undef;
my $default_size_edge = undef;
my $input_file = $ARGV[0];
my $output_file = $ARGV[1];
my @array_rec_group;
my %cost_edge;
my %cost_node;
my %predecessors;
my %successors;
my %list;
my $group;
my $uniq=0;
my %list_ini;
my $last_fork;
my $last_succ;
my $recur=0;
my %size;
srand (time ^ $$ ^ unpack "%L*", `ps axww | gzip -f`);
sub split_group{
  $recur++;
  my $comp=keys(%list_ini);
  print "uniq : $uniq recur = $recur num = $comp\n";
  return if ($comp <= 50);
  my @result;
  my $group_min;
  my $min;
  my $k;
  for($k=0;$k<10;$k++){
    $group={};
    %list = %list_ini;
    my $num = keys(%list);
    my @array = keys(%list);
    my $i = int(rand($num));

    push @result, $array[$i];
    $group->{$array[$i]}= 0;
    delete_relations($array[$i]);

    $num = keys(%list);
    my $tmp=0;
    unless ($num==0){
      @array = keys(%list);
      $i = int(rand($num));
      push @result, $array[$i];
      $group->{$array[$i]}= 1;
      %list = %list_ini;
      $num = 0;
      $size{0} = 1;
      $size{1} = 1;
      compose(2);
      $num = 0;
      foreach (keys %$group){
        $tmp++ if $group->{$_} == 0;
        $num++ unless $group->{$_} == 0;
      }
    }

    my $int1=$size{0};
    my $int2=$size{1};
    compose_rec(2);

    add_group_to_min();
    $tmp = 0;
    $num = 0;
    foreach (keys %$group){
      $tmp++ if $group->{$_} == 0;
      $num++ if $group->{$_} == 1;
    }
    $int1=$size{0};
    $int2=$size{1};
    if($int1<$int2){
      unless (defined $min){
        $min=$int1;
        $group_min=$group;
      }
      if($min<=$int1){
        $min=$int1;
        $group_min=$group;
      }
    }else{
      unless (defined $min){
        $min=$int2;
        $group_min=$group;
      }
      if($min<=$int2){
        $min=$int2;
        $group_min=$group;
      }
    }
  }
  $group = $group_min;
#fusion();
  group_succ();
  group_pred();
# $num = (keys %$group);
# $tmp = (keys %list_ini);
  my @fork=add_fork();
  $uniq++;
  my %hash1;
  my %hash2;
  $last_succ=shift @fork;
  my $succ=$last_succ;
  $last_fork=shift @fork;
  foreach(keys %$group){
    $hash1{$_}=1 if($group->{$_}==0);
  }
  foreach(keys %$group){
    $hash2{$_}=1 if($group->{$_}==1);
  }
  %list_ini=%hash1;
  $comp = keys(%list_ini);
  print "recur 1 uniq : $uniq recur = $recur num = $comp\n";
  split_group();
  $recur--;
  $last_succ=$succ;
  $last_fork=shift @fork;
  %list_ini=%hash2;
  $comp = keys(%list_ini);
  print "recur 2 uniq : $uniq recur = $recur num = $comp\n";
  split_group();
  $recur--;
}
sub add_fork(){
  foreach (keys %$group){
    my $key = $group->{$_};
    my $prec;
    my $true_prec=0;
    my $succ;
    my $true_succ=0;
    foreach $prec (@{$predecessors{$_}}){
        if(defined  $group->{$prec} and $group->{$prec} == $key){
          $true_prec= 1;
          last;
        }
    }
    foreach $succ (@{$successors{$_}}){
        if(defined $group->{$succ} and $group->{$succ} == $key){
          $true_succ= 1;
          last;
        }
    }
    my $target1="taskfork_$uniq\_$key";
    if(defined $last_fork){
      $cost_edge{"$last_fork -> taskfork_$uniq\_0"} = 1;
      $cost_edge{"$last_fork -> taskfork_$uniq\_1"} = 1;
      $cost_edge{"$last_fork -> taskfork_$uniq\_3"} = 1;
      $cost_edge{"taskfork_$uniq\_0 -> $last_succ"} = 1;
      $cost_edge{"taskfork_$uniq\_1 -> $last_succ"} = 1;
      $cost_edge{"taskfork_$uniq\_2 -> $last_succ"} = 1;
    }
    if($true_succ==0){
      if($key<2){
        $cost_edge{"$_ -> taskfork_$uniq\_2"} = 1;
      }
      if($key==3){
        $cost_edge{"$_ -> taskfork_$uniq\_0"} = 1;
        $cost_edge{"$_ -> taskfork_$uniq\_1"} = 1;
      }
      if($key==2 and defined $last_fork){
        $cost_edge{"$_ -> $last_succ"} = 1;
      }
    }
    if($true_prec==0){
      $cost_edge{"$target1 -> $_"} = 1;
    }
  }
  return ("taskfork_$uniq\_2", "taskfork_$uniq\_0","taskfork_$uniq\_1");
}
sub group_succ(){
  foreach (keys %list_ini){
    next if defined $group->{$_};
    $group->{$_} = 2 if(parcour_succ($_,2)==0);
  }

}
sub group_pred(){
  foreach (keys %list_ini){
    next if defined $group->{$_};
    $group->{$_} = 3 if(parcour_pred($_,3)==0);
  }

}

sub add_group_to_min()
{
  my $min = 0;
  $min = 1 if ($size{1} < $size{0});
  %list = %list_ini;
  while (keys %list > 1){
    $min = 1 if ($size{1} < $size{0});
    $min = 0 unless ($size{1} < $size{0});
    %list = %list_ini;
    delete_relations($_) foreach (keys %$group);
    my $num = keys(%list);
    unless($num == 0){
    my @array = keys(%list);
    my $i = int(rand($num));
    $size{$min}++;
    $group->{$array[$i]} = $min;
#compose_succ($min);
#   compose_prec($min);
    compose_all($min);
    }
  }
}

sub compose{
  my $num = shift;
  my $i = 0;
  while($i < $num){
    compose_succ($i);
    compose_prec($i);
    $i++;
  }
}
sub compose_rec{
  my $num = shift;
  my $i = 0;
  while($i < $num){
    compose_all($i);
    $i++;
  }
}
sub compose_all{
  my $i=shift;
  my @elems;
  my %succ;
  foreach (keys %$group){
    push @elems, $_ if ($group->{$_} == $i);
  }
  foreach (@elems){
    my $tmp;
    foreach $tmp ( @{$successors{$_}}){
      $succ{$tmp} = 1;
    }
    foreach $tmp ( @{$predecessors{$_}}){
      $succ{$tmp} = 1;
    }
  }
  foreach (keys %succ){
    if (defined $list_ini{$_} and not defined $group->{$_} and parcour_pred($_,$i) == 0 and parcour_succ($_,$i) == 0){
      $group->{$_}=$i ;
      $size{$i}++;
      compose_elem($_,$i);
    }
  }
}
sub compose_succ{
  my $i=shift;
  my @elems;
  my %succ;
  foreach (keys %$group){
    push @elems, $_ if ($group->{$_} == $i);
  }
  foreach (@elems){
    my $tmp;
    foreach $tmp ( @{$successors{$_}}){
      $succ{$tmp} = 1;
    }
  }
  foreach (keys %succ){
    next if(defined $group->{$_} or not defined $list_ini{$_});
    if (parcour_pred($_,$i) == 0){
      $group->{$_}=$i ;
      $size{$i}++;
# print "return really 0 for: $_ i : $i\n";
      compose_succ_elem($_,$i);
    }else{
#     print "return really 1 for: $_ i : $i\n";
    }
  }
}
sub compose_prec{
  my $i=shift;
  my @elems;
  my %succ;
  foreach (keys %$group){
    push @elems, $_ if ($group->{$_} == $i);
  }
  foreach (@elems){
    my $tmp;
    foreach $tmp ( @{$predecessors{$_}}){
      $succ{$tmp} = 1;
    }
  }
  foreach (keys %succ){
    next if(defined $group->{$_} or not defined $list_ini{$_});
    if (parcour_succ($_,$i) == 0){
      $group->{$_}=$i ;
      $size{$i}++;
# print "return really 0 for: $_ i : $i\n";
      compose_prec_elem($_,$i);
    }else{
#     print "return really 1 for: $_ i : $i\n";
    }
  }
}
sub compose_elem{
  my $elem = shift;
  my $i=shift;
  foreach ( @{$successors{$elem}}){
    if (defined $list_ini{$_} and not defined $group->{$_} and parcour_pred($_,$i) == 0 and parcour_succ($_,$i) == 0){
      $group->{$_}=$i ;
      $size{$i}++;
      compose_elem($_,$i);
    }
  }
  foreach ( @{$predecessors{$elem}}){
    if (defined $list_ini{$_} and not defined $group->{$_} and parcour_pred($_,$i) == 0 and parcour_succ($_,$i) == 0){
      $group->{$_}=$i ;
      $size{$i}++;
      compose_elem($_,$i);
    }
  }
}
sub compose_succ_elem{
  my $elem = shift;
  my $i=shift;
  foreach ( @{$successors{$elem}}){
    next if(defined $group->{$_} or not defined $list_ini{$_});
    if (parcour_pred($_,$i) == 0){
      $group->{$_}=$i ;
      $size{$i}++;
      compose_succ_elem($_,$i);
    }
  }
}
sub compose_prec_elem{
  my $elem = shift;
  my $i=shift;
  foreach ( @{$predecessors{$elem}}){
    next if(defined $group->{$_} or not defined $list_ini{$_});
    if ( parcour_succ($_,$i) == 0){
      $group->{$_}=$i ;
      $size{$i}++;
      compose_prec_elem($_,$i);
    }
  }
}
sub parcour_pred{
  my $elem = shift;
  my $i = shift;
  foreach (@{$predecessors{$elem}}){
    my $result;
    unless (defined $group->{$_}){
      $result = parcour_pred($_,$i);
    }
    if (defined $group->{$_}){
      next if ( $group->{$_} == $i);
      return 1 unless ( $group->{$_} == $i);
    }
    return 1 unless $result == 0;
  }
  return 0;
}

sub parcour_succ{
  my $elem = shift;
  my $i = shift;
  foreach (@{$successors{$elem}}){
    my $result;
    unless (defined $group->{$_}){
      $result = parcour_succ($_,$i);
    }
    if (defined $group->{$_}){
      next if ( $group->{$_} == $i);
      return 1 unless ( $group->{$_} == $i);
    }
    return 1 unless $result == 0;
  }
  return 0;
}

sub delete_relations{
  my $elem = shift;
  delete $list{$elem};
  foreach (@{$predecessors{$elem}})
  {
    delete_pred($_);
  }
  foreach (@{$successors{$elem}})
  {
    delete_succ($_);
  }
}
sub delete_pred{
  my $elem = shift;
  delete $list{$elem};
  foreach (@{$predecessors{$elem}})
  {
    delete_pred($_) if defined $list{$_};
  }

}
sub delete_succ{
  my $elem = shift;
  delete $list{$elem};
  foreach (@{$successors{$elem}})
  {
    delete_succ($_) if defined $list{$_};;
  }

}


open( FILE, "< $input_file");

while(<FILE>){
  if(/node\s*\[([^\]]*)\];/){
    $default_size_node = $1;
  }elsif (/edge\s*\[([^\]]*)\];/){
    $default_size_edge = $1;
  }elsif (/^\s*([^ -]*)\s*(\[([^\]]*)\])?;/){
    my $option = $3;
    my $target1 = $1;
    $target1 = $1 if($target1 =~ /^"(.*)"$/);
    $option = 1 unless defined $option;
    $cost_node{"$target1"} = $option;
    $list{$target1}=1;
  }

  if (/(\S*)\s*->\s*(\S*)\s*(\[([^\]]*)\])?;/){
    my $option = $4;
    $option = 1 unless defined $option;
    my $target1 = $1;
    my $target2 = $2;
    $target1 = $1 if($target1 =~ /^"(.*)"$/);
    $target2 = $1 if($target2 =~ /^"(.*)"$/);
    $cost_edge{"$target1 -> $target2"} = $option;
    if (defined $predecessors{$target2}){
      push @{$predecessors{$target2}}, $target1;
    }else{
      $predecessors{$target2} = [$target1];
    }
    if (defined $successors{$target1}){
      push @{$successors{$target1}}, $target2;
    }else{
      $successors{$target1} = [$target2];
    }
  }
}
close(FILE);

%list_ini=%list;
split_group();

if(not defined $default_size_node){
  print " the default value for node is now : \n"
}
if(not defined $default_size_edge){
  print " the default value for edge is now : \n"
}

open( FILE, "> $output_file");
print FILE "digraph g {\n";
print FILE "\t node [style=filled]; \n";
print FILE "\t edge [$default_size_edge]; \n";
my $key;
foreach $key (keys %cost_node){
  my $option = $cost_node{$key};
  $option =  "size=0" if($key =~ /taskfork/);
  print FILE "\t $key [$option]; \n" if ($option !~ /^1$/);
  print FILE "\t $key; \n" unless ($option !~ /^1$/);
}
foreach $key (keys %cost_edge){
  my $option = $cost_edge{$key};
  print FILE "\t $1 [size=0]; \n" if($key =~ /(taskfork\S*) ->/);
  print FILE "\t $1 [size=0]; \n" if($key =~ /-> (taskfork\S*);/);
  $option =  "size=0" if($key =~ /taskfork/);
  print FILE "\t $key [$option]; \n" if ($option !~ /^1$/);
  print FILE "\t $key; \n" unless ($option !~ /^1$/);
}
print FILE "}";
close(FILE);
#
#open( FILE, "> $output_file\_a");
#print FILE "digraph g {\n";
#print FILE "\t node [style=filled]; \n";
#print FILE "\t edge [$default_size_edge]; \n";
#foreach $key (keys %cost_node){
#  next unless($group->{$key} == 0);
#  my $option = $cost_node{$key};
#  print FILE "\t $key [$option]; \n" if ($option !~ /^1$/);
#  print FILE "\t $key; \n" unless ($option !~ /^1$/);
#}
#foreach $key (keys %cost_edge){
#  my $option = $cost_edge{$key};
#  if($key =~ /^\s*(\S*)\s*->\s*(\S*)$/){
#    next if ($group->{$1} != 0 or $group->{$1} != $group->{$2});
#  }
#  print FILE "\t $key [$option]; \n" if ($option !~ /^1$/);
#  print FILE "\t $key; \n" unless ($option !~ /^1$/);
#}
#print FILE "}";
#close(FILE);
#open( FILE, "> $output_file\_b");
#print FILE "digraph g {\n";
#print FILE "\t node [style=filled]; \n";
#print FILE "\t edge [$default_size_edge]; \n";
#foreach $key (keys %cost_node){
#  next unless($group->{$key} == 1);
#  my $option = $cost_node{$key};
#  print FILE "\t $key [$option]; \n" if ($option !~ /^1$/);
#  print FILE "\t $key; \n" unless ($option !~ /^1$/);
#}
#foreach $key (keys %cost_edge){
#  my $option = $cost_edge{$key};
#  if($key =~ /^\s*(\S*)\s*->\s*(\S*)$/){
#    next if ($group->{$1} != 1 or $group->{$1} != $group->{$2});
#  }
#  print FILE "\t $key [$option]; \n" if ($option !~ /^1$/);
#  print FILE "\t $key; \n" unless ($option !~ /^1$/);
#}
#print FILE "}";
#close(FILE);
