#!/usr/bin/perl -w
use strict;

		scalar @ARGV >= 1 or die "Usage:\n\t./generate_random_deployment.pl <number_of_machines_inside_sluster> <number_of_clusters> <number_of_flows> <latency_inter_cluster> <bw_inter_cluster> <latency_intra_cluster> <bw_intra_cluster>\n\n";
    my ($nb_m,$nb_c,$power,$latency_out_c,$bw_out_c,$latency_in_c,$bw_in_c) = @ARGV;
		$latency_in_c = $latency_in_c/2;
		my $i;
		print "<?xml version='3'?>\n";
		print "<!DOCTYPE platform SYSTEM \"simgrid.dtd\">\n";
		print "<platform version=\"3\">\n";
		print "<AS  id=\"AS0\"  routing=\"Full\">\n";

		for($i=0;$i<$nb_c;$i++){
		my $start = $i*$nb_m;
		my $end = ($i+1)*$nb_m - 1;
			print "<cluster id=\"c_$i\" prefix=\"c-\" suffix=\".me\" \n";
			print "radical=\"$start-$end\" power=\"$power\" ";
			printf "bw=\"%d\"  lat=\"%0.10f\"\n",$bw_in_c,$latency_in_c;
			print "bb_bw=\"2250000000\" bb_lat=\"5E-4\"/>\n";
		}
		my $nb_l=0;
		for($i=0;$i<$nb_c;$i++){
			my $j=0;
			for($j=0;$j<$nb_c;$j++){
				next if($i==$j);
				$nb_l++;
				printf "<link id=\"l_%d\" bandwidth=\"%d\" latency=\"%0.10f\"/>\n", $nb_l, $bw_out_c,$latency_out_c;
				print "<ASroute src=\"c_$i\" dst=\"c_$j\"   gw_src=\"c-c_$i\_router.me\" ";
				print "  gw_dst=\"c-c_$i\_router.me\"><link_ctn id=\"l_$nb_l\"/>\n";
				print "</ASroute>\n";
			}
		}
		print "</AS>\n";
		print "</platform>\n";

