#!/usr/bin/perl
my $default_size_node = undef;
my $default_size_edge = undef;
my $input_file = $ARGV[0];
my $output_file = $ARGV[1];

my %cost_edge;
my %cost_node;

open( FILE, "< $input_file");

while(<FILE>){
	if(/node\s*\[([^\]]*)\];/){
		$default_size_node = $1;
	}elsif (/edge\s*\[([^\]]*)\];/){
		$default_size_edge = $1;
	}elsif (/^\s*"(\S*)"\s*(\[([^\]]*)\])?;/){
		my $target1 = $1;
		$target1 = $1 if($target1 =~ /^"(.*)"$/);
		$cost_node{$target1} = 1;
	}

	if (/"(\S*)"\s*->\s*"(\S*)"\s*(\[([^\]]*)\])?;/){
		my $target1 = $1;
		my $target2 = $2;
    $cost_node{$target1} = 1;
    $cost_node{$target2} = 1;
		$puits{$target2} = 1;
		$source{$target1} = 1;
	}
}
close(FILE);
foreach (keys %cost_node){
 print "$_\n" if (not defined $source{$_});# or not defined $puits{$target2});
 print "$_\n" if (not defined $puits{$_});
}
